#v1.1.1
require 'sketchup.rb'

def get_instance(ent, def_name)
   output = ""
   ent.instances.each do |e|
      orig = e.transformation.origin
     # output << "#{def_name},#{e.bounds.width},#{e.bounds.depth},#{e.bounds.height},#{orig.x},#{orig.y},#{orig.z}\n"
      output << "#{def_name},#{e.bounds.width},#{e.bounds.depth},#{e.bounds.height}\n"
   end
   output
end

def get_all_items
   out = ""
   Sketchup.active_model.definitions.each do |e| 
      out << get_instance(e, e.name)
   end
   out
end

def get_instance_login(ent, def_name)
   output = ""
   ent.instances.each do |e|
      orig = e.transformation.origin
     # output << "#{def_name},#{e.bounds.width},#{e.bounds.depth},#{e.bounds.height},#{orig.x},#{orig.y},#{orig.z}:"
      output << "#{def_name},#{e.bounds.width},#{e.bounds.depth},#{e.bounds.height}:"
   end
   output
end

def get_all_items_login
   out = ""
   Sketchup.active_model.definitions.each do |e| 
      out << get_instance_login(e, e.name)
   end
   out
end

def export_items
   flomoco_login = "demo@flomoco.com"


   if(flomoco_login != "")
		model_data = "FloMoCo Component Reporter v1.1.0\n"
   		model_data = model_data + get_all_items_login
   		#model_data.gsub!('"','%22')
   		#model_data.gsub!('~','%7E')
   		web_data = "remail=" + flomoco_login + "&data=" + model_data;
   		dialog = UI::WebDialog.new("FloMoCo 80/20 Instant Quoter", true, "FloMoCo_Quoter_Page", 50,50, 20, 20, true)
   		dialog.show
   		dialog.post_url("http://www.flomoco.com/c/8020_IQ_Login.pl",web_data)
   		UI.openURL "http://www.flomoco.com/c/8020_IQ_Login.pl?temail=#{flomoco_login}" 
  else
		file_name = File.dirname(__FILE__)+"/FloMoCo_8020_BoM.txt"
   		f = File.new(file_name,"w")
   		model_data = "FloMoCo Component Reporter v1.1.0\n"
   		model_data = model_data + get_all_items
   		f.write model_data
   		f.close
  		UI.openURL "file://#{file_name}"
   end
end

if( not file_loaded?("FloMoCo_8020_quoter.rb") )

    add_separator_to_menu("Plugins")
	UI.menu("Plugins").add_item("Generate FloMoCo 8020 BoM...") { export_items}
end#if

file_loaded("FloMoCo_8020_quoter.rb")
